﻿using System;
using StudioX.Authorization.Users;
using StudioX.Extensions;

namespace StudioX.Boilerplate.Authorization.Users
{
    public class User : StudioXUser<User>
    {
        public const string DefaultPassword = "123qwe";

        public const string DefaultEmailAddress = "default@studioxsoftware.com";

        public static string CreateRandomPassword()
        {
            return Guid.NewGuid().ToString("N").Truncate(16);
        }

        public static User CreateTenantAdminUser(int tenantId, string emailAddress)
        {
            var user = new User
            {
                TenantId = tenantId,
                UserName = AdminUserName,
                FirstName = AdminUserName,
                LastName = AdminUserName,
                EmailAddress = emailAddress
            };

            user.SetNormalizedNames();

            return user;
        }
    }
}